package com.cicdi.notify;

import java.util.Map;
import java.util.Optional;

/**
 * 通知器属性
 *
 * @author xueye
 */
public class NotifierProperties {

    /**
     * 唯一标识
     */
    private String id;

    /**
     * 通知类型标识
     *
     * @see NotifyType
     */
    private String type;

    /**
     * 通知服务提供商标识,如: aliyun ...
     */
    private String provider;

    /**
     * 配置名称
     */
    private String name;

    /**
     * 配置内容,不同的服务提供商,配置不同.
     *
     * @see NotifierProvider
     */
    private Map<String, Object> configuration;



    public Optional<Object> getConfig(String key) {
        return Optional.ofNullable(configuration)
                .map(conf -> conf.get(key));
    }

    public Object getConfigOrNull(String key) {
        return Optional.ofNullable(configuration)
                .map(conf -> conf.get(key))
                .orElse(null);
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getProvider() {
        return provider;
    }

    public void setProvider(String provider) {
        this.provider = provider;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Map<String, Object> getConfiguration() {
        return configuration;
    }

    public void setConfiguration(Map<String, Object> configuration) {
        this.configuration = configuration;
    }
}
